unit PseudoColor;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ExtDlgs;

type
  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    Image1: TImage;
    GrayBtn: TButton;
    Image2: TImage;
    Image3: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    Pseudo_ColorBtn: TButton;
    SorceBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GrayBtnClick(Sender: TObject);
    procedure Pseudo_ColorBtnClick(Sender: TObject);
    procedure SorceBtnClick(Sender: TObject);
  private
    { Private 錾 }
    procedure MakeTemp;                   // J[ev[g쐬
    procedure MonoColorBar;               // mNJ[o[
    procedure ColorBar;                   // J[o[
    procedure ConvertGray;                // O[XP[ϊ
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// t@Cgqݒ
const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  kr  = 0.299;                     // R PxϊW
  kg  = 0.587;                     // G PxϊW
  kb  = 0.114;                     // B PxϊW

var
  ColorTemp : array[0..255] of TColor;          // J[ev[g
  GrayScale : array of array of Byte;
  InBitmap        : TBitmap;                    // rbg}bv
  OutBitmap       : TBitmap;
  GHeight, GWidth : integer;                    // \[X摜TCY
  VRect           : Trect;                      // \TCYݒp

type
  TPrgbarry = array[0..0] of Trgbtriple;      // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarray  = ^TPrgbarry;                    // |C^[
                                              // z̃|C^[KvȂȂ̂ŁA1 [0..0]Ŗ肠܂B
//======================
// O[XP[ϊ
//======================
procedure TForm1.ConvertGray;
var
  PB    : Prgbarray;
  X, Y  : Integer;
begin
  for Y := 0 to GHeight - 1 do begin
    PB := InBitmap.ScanLine[Y];
    for X := 0 to GWidth -1 do
      GrayScale[Y, X] := Round(PB[X].rgbtBlue  * kb +
                               PB[X].rgbtGreen * kg +
                               PB[X].rgbtRed   * kr); // Pxϊ
  end;
end;

//==========================
// mNJ[o[ 쐬
//==========================
procedure TForm1.MonoColorBar;
var
  II: Integer;
  C : Integer;
begin
  for II := 0 to 255 do begin
    C := II * 256 * 256 + II * 256 + II;
    Image1.Canvas.Pen.Color := C;
    Image1.Canvas.MoveTo(II, 0);
    Image1.Canvas.LineTo(II, 30);
  end;
end;

//===============================
// OCXP[\
//===============================
procedure TForm1.GrayBtnClick(Sender: TObject);
var
  PB    : Prgbarray;
  X, Y  : Integer;
begin
  for Y := 0 to GHeight - 1 do begin
    PB := OutBitmap.ScanLine[Y];
    for X := 0 to GWidth -1 do begin
      PB[X].rgbtBlue  := GrayScale[Y, X];
      PB[X].rgbtGreen := GrayScale[Y, X];
      PB[X].rgbtRed   := GrayScale[Y, X];
    end;
  end;
  Image3.Canvas.StretchDraw(VRect, OutBitmap);              // o͘gɕϔ{o
end;

//================================
// [J[\
//================================
procedure TForm1.Pseudo_ColorBtnClick(Sender: TObject);
var
  PB    : Prgbarray;
  X, Y  : Integer;
  TC    : TColor;
begin
  for Y := 0 to GHeight - 1 do begin
    PB := OutBitmap.ScanLine[Y];
    for X := 0 to GWidth -1 do begin
      TC := ColorTemp[GrayScale[Y, X]];
      PB[X].rgbtBlue  := GetBValue(TC);
      PB[X].rgbtGreen := GetGValue(TC);
      PB[X].rgbtRed   := GetRValue(TC);
    end;
  end;
  Image3.Canvas.StretchDraw(VRect, OutBitmap);              // o͘gɕϔ{o
end;

//============================
// 摜\
//============================
procedure TForm1.SorceBtnClick(Sender: TObject);
begin
  Image3.Canvas.StretchDraw(VRect, InBitmap);              // o͘gɕϔ{o
end;

//=========================
// J[o[  쐬
//=========================
procedure TForm1.ColorBar;
var
  II : Integer;
begin
  for II := 0 to 255 do begin
    Image2.Canvas.Pen.Color := ColorTemp[II];
    Image2.Canvas.MoveTo(II, 0);
    Image2.Canvas.LineTo(II, 30);
  end;
end;

//============================
// J[ev[g쐬
//============================
procedure TForm1.MakeTemp;
var
  II      : Integer;
  R, B, G : Integer;
begin
  for II := 0 to 255 do begin
    B := 0;                                     // RGB
    G := 0;
    R := 0;
    if II <= 63 then begin                      // II 0`63
      B := 255;
      G := II * 4;
    end;
    if (II >= 64) and (II <= 127) then begin    // II 64`127
      B := (255 - (II - 64) * 4);
      G := 255;
    end;
    if (II >= 128) and (II <= 191) then begin   // II 128`191
      G := 255;
      R := (II - 128) * 4;
    end;
    if (II >= 192) then begin                   // II 192`255
      G := (255 - (II - 192) * 4);
      R := 255;
    end;
    B := B shl 16;                              // Vtg16bit
    G := G shl  8;                              // Vtg 8bit
    ColorTemp[II] := B + G + R;                 // OFZ
  end;
end;

//====================================
// 摜t@C̃I[v
//====================================
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  InFilename  : String;
  IHeight     : Integer;
  IWidth      : Integer;
begin
  OpenPictureDialog1.Filter := OpenFileFilter;              // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                        // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                              // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;          // t@C̎擾
        WIC.LoadFromFile(InFilename);                       // 摜̓ǂݍ
        GHeight := WIC.Height;                              // 摜擾
        GWidth  := WIC.Width;                               // 摜
        IWidth  := Image3.Width;                            // o͐C[W1̕
        IHeight := Image3.Height;                           // o͐C[W1̍
        if GHeight <= GWidth then begin                     // cɂo̓TCYݒ
          IHeight := Round(IWidth * GHeight / GWidth);
        end
        else
        begin
          IWidth := Round(IHeight * GWidth / GHeight);
        end;
        VRect := Rect(0, 0, IWidth, IHeight);               // o͘gݒ
        InBitmap.Assign(WIC);
      finally
        WIC.Free;                                           // TWICImage 
      end;
      InBitmap.PixelFormat  := pf24bit;
      Image3.Canvas.StretchDraw(VRect, InBitmap);           // o͘gɕϔ{o
      setlength(GrayScale, GHeight, GWidth);
      OutBitmap.PixelFormat := pf24bit;
      OutBitmap.Height := GHeight;
      OutBitmap.Width  := GWidth;
    end
    else Exit;
  ConvertGray;                                              // O[XP[ϊ
  GrayBtn.Enabled := True;
  Pseudo_ColorBtn.Enabled := True;
  SorceBtn.Enabled := True;
end;

//=================
// ݒ
//=================
procedure TForm1.FormCreate(Sender: TObject);
var
  Bitmap : Tbitmap;
begin
  top := (Screen.Height - Height) div 2;
  left := (Screen.Width - Width) div 2;
  Image1.Width := 256;
  Image1.Height := 30;
  Image2.Width := Image1.Width;
  Image2.Height := Image1.Height;
  Image3.Width := 256;
  Image3.Height := 256;
  Bitmap := Tbitmap.Create;                       // prbg}bv
  Bitmap.Width := Image1.Width;
  Bitmap.Height := Image1.Height;
  Image1.Picture.Bitmap := Bitmap;
  Image2.Picture.Bitmap := Bitmap;
  Bitmap.Free;                                    // prbg}bv̔j
  Image1.Picture.Bitmap.PixelFormat := pf24bit;
  Image2.Picture.Bitmap.PixelFormat := pf24bit;
  MakeTemp;                                       // J[ev[g쐬
  MonoColorBar;                                   // mNJ[o[
  ColorBar;                                       // J[o[
  InBitmap  := TBitmap.Create;                    // rbg}bv
  OutBitmap := TBitmap.Create;
  GrayBtn.Enabled := False;                       // {^̐ݒ
  Pseudo_ColorBtn.Enabled := False;
  SorceBtn.Enabled := False;
end;

//==================================
// I Ɨprbg}bv̊J
//==================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InBitmap.Free;
  OutBitmap.Free;
end;

end.
